	page	,132
	title	DSXEGAA4.ASM --EGA Driver
	subttl	Definitions, Equates and Data Areas
	name	DSXEGAA4

;5/4/89  0910 hrs

;convert far procs to all near,
;change segment register usage, kill all ROM BIOS refs
;update struct definition, change bp to ebp, etc.
;-----------
;Notes: * even though you may tell the C compiler an argument is
;a short, 4 bytes will be pushed!
;	* USE32 directive makes all operations default to DWORD
;	* need align 4 directive before each code entry point
;	* ARGS is now 8, was 6 bytes!
;2/14 - hook up fdraw
;2/27 - debug remove
;4/3 - to make High C happy, preserve edi
;4/21 - start expanding display list size
;4/30 - add initpal routine to initialize pallete
;5/1 - fiddle pallete to try to match desired colors
;5/4 - disconnect remove

	.386

comment /

     (C) Copyright 1982,83,84,85,86,87,88,89	by Autodesk, Inc.

	This program is copyrighted by Autodesk, Inc. and is
	furnished pursuant to a software license agreement.  The
	source code of this program may not be distributed or
	published in any form by the licensee.	Licensee is free to
	incorporate this code in object form in derivative works
	providing such derivative works are solely intended to work
	with Autodesk, Inc. products.  Said derivative works,
	incorporating object versions of this program may be
	distributed without royalty at the discretion of the licensee.

	Autodesk makes no warranties, express or implied, as to the
	correctness of this code or any derivative works which
        incorporate it.  Autodesk provides this code on an ``as-is''
	basis and explicitly disclaims any liability, express or
	implied, for errors, omissions, and other problems in the
	code, including consequential and incidental damages.

*****************************************************************************/
;

;       Many of the functions take a "properties" argument.  This argument
;	is a byte formatted as follows:
;
prop	record	mcolor:4, hilite:2, xormode:1
;
;	An mcolor of zero is the background color (black).  Anything else
;	is a standard AutoCAD color.  A hilite of zero means no
;       highlighting.  A value of one requests "selection" highlighting
;       and anything else requests "error" highlighting.  Xormode is
;       zero for normal ink and 1 for "XOR" ink.
;
;       For those of you unfamilliar with the assembler's "record"
;       mechanism, "mcolor" has a value of 3, the shift count to
;       right-justify the field.  "MASK mcolor" has the value 078h,
;	the mask of bits containing field mcolor.


;		      Ports, Addressing and Bits
;
; THE FOLLOWING IS THE BEST I COULD DO AT TRYING TO UNDERSTAND THE RATHER
; INADEQUATE IBM DOCUMENTATION.  I TRIED TO MAKE SURE EVERYTHING WAS BOTH
; CONSISTANT WITH THE DOCUMENTATION AND REASONABLE, BUT UNFORTUNATELY, IT
; WASN'T POSSIBLE TO ASSURE BOTH.  I OPTED FOR REASONABLENESS.
;
; "In graphics mode each pel is mapped to one bit in the address space.
; The color or attribute of a given pel is determined by the four bits
; on the four memory planes behind a given bit address."
;
; During reading, data from the REGEN buffer gets to the CPU as follows:
;	1.  Read out 32 bits, one byte from each plane at the specified
;	    address into the latches.
;	2.  If read mode zero is specified in G_MODE, then simply select
;	    the data from the latch whose number is in the Read Map Select
;	    register (G_READ_MAP).  If read mode one is specified in G_MODE,
;	    then for each bit, form a four bit value--one bit from each
;	    8 bit latch.  If the four bits match the value in the color
;	    compare register (G_CLR_COMP), then return a one to the CPU in
;	    that bit position.	Otherwise, that bit is read as zero.  While
;           comparing with the color compare register, the color don't care
;	    register specifies a mask of bits which are always considered to
;	    match.
;
; During writing, eight data bits from the CPU are handled as follows:
;	1.  Rotate right by the count in G_DATA_ROT.
;	2.  Convert the 8 data bits from the CPU to 32 bits (8 bits for
;	    each plane) based on the current write mode in G_MODE.
;	    0.	For write mode 0, duplicate the 8 bits 4 times, once for
;		each plane.  For any plane whose set/reset enable bit is
;		set (in the G_ENBL_SET register), use 8 copies of the
;		corresponding bit in the G_SET_RESET register instead of
;		a copy of the CPU data.
;	    1.	For write mode 1, ignore the CPU data and substitute the
;		32 bits in the latches.
;	    2.	For write mode 2, bit 0 of the CPU data is replicated
;		eight times to form a byte for plane 0.  Bit 1 of CPU
;		data forms a byte for plane 1.	Bit 2 goes for plane 2 and
;		bit 3 goes for plane 3.  The high-order bits are ignored.
;	3.  Based on the function select (in register G_DATA_ROT), take the
;	    32 bits and combine them logically with the 32 bits in the
;	    latches.
;	4.  For each plane, select bits from either the corresponding data
;	    of step 3 or from the latches.  The eight bit selection mask
;	    (used for all 4 planes) is in the G_BIT_MASK register.
;	5.  For those planes enabled by the S_MAP register in the sequencer,
;	    store the data into the REGEN buffer.
;
; The four planes are as follows:
INTENSE 	EQU	3
RED		EQU	2
GREEN		EQU	1
BLUE		EQU	0

; The (relevant) hardware registers are:
SEQ_ADDR	EQU	0C4h		;Sequencer chip
SCHIP		EQU	SEQ_ADDR+300h
	S_RESET 	EQU	0
;		01h	Asynchronous Reset
;		02h	Synchronous Reset
	S_CLOCK 	EQU	1
;		01h	8 Dots per character if set; else 9 dots wide
;		02h	Bandwidth (CRT gets 2 of 5 cycles if set else 4 of 5)
;		04h	Shift Load (reload serializer every OTHER char clock)
;		08h	Dot Clock (divide clock by 2 for 320 x 200 modes)
	S_MAP		EQU	2
;		01h	Enable Map 0
;		02h	Enable Map 1
;		04h	Enable Map 2
;		08h	Enable Map 3
	S_CGEN		EQU	3
;		03h	Character Map Select B
;		0Ch	Character Map Select A
	S_MEM		EQU	4
;		01h	Alpha mode (as opposed to Graphic mode)
;		02h	Extended Memory (>64K) addressing enabled
;		04h	Odd/Even disable.  If bit 04h is set, normal
;			addressing occurs.  If bit 04h is clear, then even
;			CPU addresses reference maps 0 and 2 and odd CPU
;			addresses reference maps 1 and 3.  (In odd/even mode,
;			the address is right shifted one bit to determine the
;			acutal offset.	In this mode, map enables for maps 0
;			and 1 should be the same.  Similarly for maps 2 and 3.
;                       Also see bit 4 of the Graphics chips' Mode register.

GRAPH_ADDR	EQU	0CEh
GCHIP		EQU	GRAPH_ADDR+300h 	;Graphics Chip
	G_SET_RESET	EQU	0
;		0Fh	Value to write to the 4 planes on a mode 0 write with
;			set/reset mode enabled (for the corresponding plane)
	G_ENBL_SET	EQU	1
;		0Fh	Set/reset mode enable bits for the four planes.  For
;			un-enabled planes, the processor data is written.
	G_CLR_COMP	EQU	2
;		0Fh	Value to compare the 4 planes with on a mode 1 read.
;			(Returned value from read mode 1 has a 1 for each
;			4-bit pixel that matches this value or has a 1 in the
;                       Color Don't Care register.)
	G_DATA_ROT	EQU	3
;		07h	Rotate data written from the CPU (right) by the shift
;			count during write mode 0.  (Rotate occurs before
;			Set/Reset mode and the function specified below.)
;		18h	Function select.  Data written to memory, M, is data
;			in latches, L, operated on with data from CPU, C, and
;			rotate count, R.  Function applies after Set/Reset in
;			all write modes.
	   REP_MODE equ 00h	;	M = (C ROT R)
	   AND_MODE equ 08h	;	M = L AND (C ROT R)
	   OR_MODE  equ 10h	;	M = L OR (C ROT R)
	   XOR_MODE equ 18h	;	M = L XOR (C ROT R)
	G_READ_MAP	EQU	4
;		07h	Which map we are reading from.	(The documentation is
;			unclear why there are three bits.  Logically, there
;			ought to be only 2.)
	G_MODE		EQU	5
;		03h	Write mode.
;			00h	Each plane (enabled by sequencer) gets one
;				byte as specified by G_DATA_ROT.
;			01h	Each plane (enabled by sequencer?) gets current
;				latch data byte.  CPU data is ignored.
;			02h	The low-order four CPU data bits are each
;				duplicated eight times to form 4 eight bit
;				values, one for each plane.
;		04h	Diagnostic use
;		08h	Read mode.  Read mode 0 reads data from the plane
;			selected by the Read Map Select register.  Read mode
;			1 does eight color compares with the color in Color
;                       Compare Register (as modified by the Color Don't Care
;			register).  For each match, return a 1 bit.
;		10h	Select Odd/Even addressing mode.  Normally corresponds
;			to bit 3 of the Sequencer Memory Mode register.
;		20h	Direct the shift register to format the serial data
;			stream with even numbered bits on the even numbered
;			maps and odd numbered bits on the odd numbered maps.
	G_MISC		EQU	6
;		01h	Graphics mode.
;		02h	Chain odd maps to even maps.  (1 follows 0 and 3
;			follows 2.)
;		0Ch	Memory Map--Location in addressing space of REGEN
;			buffer:  00h ==> 128K at A000.	04h ==> 64K at A000.
;				 08h ==>  32K at B000.	0Ch ==> 32K at B800.
	G_COLOR 	EQU	7
;               0Fh     Don't care bits for color compare in read mode 1.
	G_BIT_MASK	EQU	8
;		FFh	If one of these bits is zero, take the corresponding
;			bit from the latch rather than from the regular source
;			during a write operation.  Applies to all four planes.

CRTC_ADDR	EQU	0D4h	;****0B4h for monochrome***
CRTC_ADDR_B	EQU	0B4h
CCHIP		EQU	CRTC_ADDR+300h		;CRT Controller Chip
CCHIP_B 	EQU	CRTC_ADDR_B+300h
	C_HRZ_TOT	EQU	0
	C_HRZ_DSP	EQU	1
	C_STRT_HRZ_BLK	EQU	2
	C_END_HRZ_BLK	EQU	3
	C_STRT_HRZ_SYN	EQU	4
	C_END_HRZ_SYN	EQU	5
	C_VRT_TOT	EQU	6
	C_OVERFLOW	EQU	7
	C_PRE_ROW	EQU	8
	C_MAX_SCAN_LN	EQU	9
	C_CRSR_START	EQU	0Ah
	C_CRSR_END	EQU	0Bh
	C_START_HGH	EQU	0Ch
	C_START_LOW	EQU	0Dh
	C_CRSR_LOC_HGH	EQU	0Eh
	C_CRSR_LOC_LOW	EQU	0Fh
	C_VRT_SYN_STRT	EQU	10h		; Write Only
	C_LGHT_PEN_HGH	EQU	10h		; Read Only
	C_VRT_SYN_END	EQU	11h		; Write Only
	C_LGHT_PEN_LOW	EQU	11h		; Read Only
	C_VRT_DSP_END	EQU	12h
	C_OFFSET	EQU	13h
	C_UNDERLN_LOC	EQU	14h
	C_STRT_VRT_BLK	EQU	15h
	C_END_VRT_BLK	EQU	16h
	C_MODE_CNTL	EQU	17h
	C_LN_COMP	EQU	18h

ATTR_READ	EQU	0DAh			/* Or 0BAh for monochrome! */
ACHIPR		EQU	300h + ATTR_READ
ATTR_WRITE	EQU	0C0h
ACHIPW		EQU	300h + ATTR_WRITE
	P_MODE		EQU	10h
	P_OVERSC	EQU	11h
	P_CPLANE	EQU	12h
	P_HPEL		EQU	13h

; The default register values setup and expected by the BIOS depends somewhat
; on the configuration and video mode.	All of the preceeding are expected
; to contain zero EXCEPT:
;	S_MAP = 0Fh
;	Odd/Even mode (in G_MODE) is set for video modes 0-4, 7 and mode F
;		(if only 64K of memory)
;	Serial Shift mode (in G_MODE) is set for video modes 4 and 5
;	Graphics mode (in G_MISC) is set for video modes 4-6 and D-10
;	Chain maps mode (in G_MISC) is set for modes 0-5, 7 and when only
;		64K, modes F and 10
;	Memory location (in G_MISC) is set to 4 for EGA native video modes,
;		to 8 for monochrome emulation mode 7 and to C for CGA
;		emulation modes 0-6.
;	G_BIT_MASK = 0FFh.



;------ AutoCAD Standard Color Definitions

ACADBLACK	equ	0		;This is really the background color
ACADRED 	equ	1
ACADYELLOW	equ	2
ACADGREEN	equ	3
ACADCYAN	equ	4
ACADBLUE	equ	5
ACADMAGENTA	equ	6
ACADWHITE	equ	7		;This is the inverse of the background

	DGROUP GROUP CONST, _BSS, _DATA

_DATA SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA ENDS
_BSS SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS ENDS
CONST SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST ENDS


_TEXT     SEGMENT  DWORD USE32 PUBLIC 'CODE'
 	ASSUME	CS:_TEXT, DS:DGROUP, SS:DGROUP, ES:DGROUP
_TEXT	ENDS


;------ Names imported from DOSEGA.C

EXTRN	_vidbuf:DWORD		;EGA REGEN buffer
EXTRN	_aybias:DWORD
EXTRN	_ovrcolor:WORD		;Overscan area color
EXTRN   _colormon:BYTE      ;EGA's color monitor flag (1)
EXTRN	_ecurwind:DWORD
EXTRN	_vpinfo:BYTE
EXTRN   _color:WORD
EXTRN	_overflow:WORD
EXTRN   _fdpoint:DWORD		;pointer to fastdraw
EXTRN	_ltop:BYTE

EXTRN	_wtranv:WORD		;for debugging 
EXTRN   _targetv:WORD           ;for debugging
EXTRN   _chreg:BYTE

_DATA   SEGMENT  

	public _curam,_curxm



wstat struc
    vpnumber	dw ?	;/* we'll use 0 to indicate unused vp */
    projid	dw ?	;/* projection id */
    vpxmin	dw ?	;/* viewport position in screen */
    vpymin	dw ?	;/* pixels */
    vpxmax	dw ?
    vpymax	dw ?
    wixdots	dw ?	;/* size of viewport (for use by clip)*/
    wiydots	dw ?
    lgxdots	dw ?	;/* size of logical space */
    lgydots	dw ?
    lgxl	dw ?	;/* viewport position in */
    lgyl	dw ?	;/* logical space */
    lgxh	dw ?
    lgyh	dw ?
    vrxl	dq ?	;/* viewport position in */
    vryl	dq ?	;/* projection space */
    vrxh	dq ?
    vryh	dq ?
    rxl		dq ?
    ryl		dq ?	;/* lower left corner in reals */
    rxh		dq ?
    ryh		dq ?	;/* upper right corner */
    dlist	dd ?	;/* display list */
    ddlist	dd ?	;/* drag display list */
    master	dw ?	;/* if slave, master viewport id */
    slaves	dw ?	;/* if master, number of slaves */
    vectors	dw ?	;/* vector status */
    vxdots	dw ?	;/* size of current viewport */
    vydots	dw ?	;/* in logical space */
    dstate	dw ?	;/* drag state */
    drx		dw ?	;/* drag offset */
    dry		dw ?
    ioffset	dd ?	;/* offset into display list of
    			;place to insert next entry */
    drs		dw ?	;/* how much drag image shown */
    dioffset	dw ?	;/* offset into drag display list */
    overflow	dw ?	;/* = 0 normally, 1 if list overflowed */
    dummy	dw ?
wstat ends

; display list data structure:
;
; dw "from X" or 8000h	; the 8000h tags this "moveonly"
; dw "from Y"		; if this has 8000h it is tagged "highlighted"
; dw  (256 * port) + color ; merge physical port number & color
; dw ffffh		;flag to identify port/color word
; dw "to X"
; dw "to Y"
; -- if this is followed by a continuation vector
; dw "to X"
; dw "to Y"
; -- until the end of continuations, then we start over with "moveonly"

_bgc db ?		;background color
os2 db ?		;off screen flags for eiclip
target dw ?		;target vpnumber
toff dd	?		;address in vpinfo
moff dw ?		;another offset into vpinfo
svp dw ?		;slave viewport #
sx1 dw ?		;save logical vector
sy1 dw ?		;during transform by eiclip
sx2 dw ?		;if we need to clip repeatedly
sy2 dw ?		;for slave viewport(s)
_egamem db 3



GREY1	equ	1010101010101010b	;level one highlighting (dim)
GREY2	equ	1001100110011001b	;level two highlighting (+ INTENSE)

row_inc		dd	?		;row increment 
rangex		dd	?		;Delta X for current vector
rangey		dd	?		;Delta Y for current vector
cureven		dw	?		;even byte flag
curspos		dd	?		;cursor bitmap start position
curline		dw	?		;number of lines in cursor
cursave		equ	480*80		;offset for cursor save area
count		db	?		;pixels in a byte
xmask		db	?		;clear-pixel mask
shiftcnt	dd	?
rowmask		dd	?
patmask		dd	?
rowstart	dd	?
rowcount	dd	?

bitmask		db	?
wbuffer		db	?		;buffer for file write
bytesout	dw	?		;for return value from file write
_curam	db (17*4) dup (?)	;AND mask for raster cursor
_curxm	db (17*4) dup (?)	;XOR mask for raster cursor
numargs		dw	0		;used by pvars

	ifdef debug

		;save locations for debugging with print statements
sax	dw	0
sbx	dw	0
scx	dw	0
sdx	dw	0
sdi	dw	0
ssi	dw	0
sbp	dw	0
sss	dw	0
ses	dw	0
scs	dw	0
sds	dw	0
sflags	dw	0
ssp	dw	0
sip	dw	0
ipl	dw	0

head	db 0dh,0ah,' ax   bx   cx   dx   di   si   bp   '
		db 'ss   es   cs   ds   fl   sp   ips  ipo',0dh,0ah,'$'

pkhead	db 'packet: $'
ahead	db 'args: $'
phead	db 0dh,0ah,' ecurwind ',0ah,'$'
	endif


;------  16/64 colors definitions 
;Black	L-Red	Yellow	L-Green L-Cyan	L-Blue	L-Mgnta Intense-White	0- 7
;Grey	Red	Brown	Green	Cyan	Blue	Magenta White		8-15
pallete db 0, 24h,3eh, 12h, 1bh, 9, 2dh, 3fh, 38h, 4, 6, 2, 3, 1, 5, 7, 0

_DATA	ENDS


_TEXT	 SEGMENT

	PUBLIC	_tbyteblt
	PUBLIC	_tadsdot
	PUBLIC	_tadsvec
	PUBLIC	_tadsglyph
	PUBLIC	_egacur, _egaccur
	PUBLIC  _luvec, _lvec, _rlvec, _slvec
	PUBLIC  _svtran, _vtran, _bgc
	PUBLIC  _fdraw, _initpal
    
	ifdef debug
    PUBLIC pvars
    endif
;------------------------------------------------------------------------------

args equ [ebp+8]
x1	equ	args+0
y1	equ	args+4	;was 2
x2	equ	args+8	;was 4
y2	equ	args+12	;was 6
props	equ	args+16	;was 8



	subttl	Macros and Internal Routines
      

;***************************** Macros ******************************

; Send A and B to ports dx and (dx+1)
; trashes al
OUT_DX		macro	A, B
		mov	al,A
		out	dx,al
		inc	edx
		mov	al,B
		out	dx,al
		dec	edx
		endm


;	Macro to convert screen coordinates to graphics buffer
;	address.  Takes x-coordinate at ARGS, y-coordinate at ARGS+2,
;	returns byte address in bx, bit number in cl (0=left).
;
;	Incidentally returns byte address of dot at (0,y) in ax.
;
;	No other registers affected.
;
EGADOT	macro	X, Y
	imul	eax,dword ptr Y,80	;row number multiplied by 80
	mov	ebx,X	 	;column number.
	mov	cl,bl		;Copy it.
	shr	ebx,3		;Divide by 8.
	and	cl,111b 	;Bit number.
	add	ebx,eax		;Byte address.
	add	ebx,_vidbuf	;base address of video memory
	endm



;***************************** INTERNAL ROUTINES ******************************


;common entry point for drawing vectors - we arrive with
;ebp already established, esi and edi pushed
	align 4
drvc	proc near
	push	ebx	

;	The following code very closely parallels the beginning of 
;	routine adsglyph.  There are slight differences due to the
;	way in which we start the hilighting pattern.  For adsvec,
;	we want to start the sequence at the first dot of the
;	vector (so that short vectors get hilighted uniformly).
;	For adsglyph, we start based on the position on the screen
;	so that adjacent areas with identical properties will blend
;	together.
	mov	eax,props	;Get properties
	mov	ebx,eax
	mov	dx,GCHIP	;Set up to load GRAPHICS chip registers
	mov	ch,11111111b	;Get an all ones mask for pattern
	shr	ebx,mcolor
	and	bl,(mask mcolor) shr mcolor
	mov	cl,bl ;Get translated color
	test	al,(mask xormode) or (mask hilite)
	jz	short adsvec3 	;No special modes
	or	cl,cl		;Are we about to try to do special in black?
	jnz	short vnotblack	;No
	xor	ebx,ebx
	or	cl,0 ;Try color zero for non-black
	jnz	short vnotblack
	mov	bl,15
	or	cl,15 ;Try color 15
	jnz	short vnotblack
	mov	bl,7
	or	cl,7 ;Use color 7

	align	4
vnotblack:
	test	al,mask xormode ;Is this an XOR request?
	jz	short dsvnoxor
;--- set function to XOR mode
	OUT_DX	G_DATA_ROT,XOR_MODE

	mov	eax,props	;Get properties
	test	al,mask hilite	;Is the vector to be highlighted too?
	jz	short adsvec3 	;No.

	align	4
dsvnoxor:
	mov	ch,high GREY1	;Yes--load grey mask 1
	test	al,(mask hilite) and ((mask hilite) - 1)
	jz	short adsvec3 	;Level one highlighting?
	mov	ch,high GREY2	;No--a little less grey
	and	bl,7		;GREY2 always implies INTENSE
	mov	al,bl 
	or	al,al		;unless the INTENSE version happens to be black
	jz	short adsvec3
	mov	cl,al

	align	4
adsvec3:
	mov	edi,ecx		;Hold the color (from CL) and pattern (from CH)
	mov	esi,x2	;x2
	sub	esi,x1 	;x2-x1
	jae	short adsvec1 	;If x1 <= x2, process in normal order
	neg	esi		;x1-x2
	EGADOT	x2,y2 ;Get starting address in ebx, and shift in cl
	mov	eax,y1	;y1
	sub	eax,y2	;y1-y2
	jmp	short adsvec2

	align	4
adsvec1:
	EGADOT	x1,y1 ;Get starting address in ebx, and shift in cl
	mov	eax,y2	;y2
	sub	eax,y1	;y2-y1

	align	4
adsvec2:
	mov	dword ptr row_inc,80	;Row-increment addend.
	jge	short posy			;If y difference is
	neg	eax				;   negative, invert it,
	mov	dword ptr row_inc,-80	;   and make the row increment
						;   negative
	align	4
posy:
	mov	rangex,esi
	mov	rangey,eax

	xchg	ebx,edi		;Put REGEN pointer into EDI; pattern/color to BX
	ror	bh,cl		;Shift pattern mask to starting bit's position
	mov	ch,80h
	ror	ch,cl		;Shift current bit to starting position

	xchg	eax,ecx		;Current bit to AH; rangey to ECX
	OUT_DX	G_MODE,2	;Set write mode 2
	mov	al,G_BIT_MASK
	out	dx,al		;Select bit mask register
	inc	edx		;We send it data repeatedly in the inner loops

	cmp	esi,ecx		;Loop on the coordinate which has the
	jle	loopony 	;   farthest to move.

; Register usage during the loops is:
;	AL needed for output to port, etc.
;	AH contains the bitmask select register value for the current bit
;	BL contains the color we are working in
;	BH contains the pattern mask
;	ECX will contain the number of dots left to do for this vector
;       DX points to graphics chip's data register (G_BIT_MASK)
;	EDI is the REGEN buffer pointer
;	ESI will be the relative-motion counter
;
;Loop is on x.
;	jecxz	jlooponx	;Special case code for horizontal lines

	align	4
looponx:
	mov	ecx,esi
	inc	ecx		;One dot more than (x2-x1).
	shr	esi,1		;Initialize the relative-motion counter to the
				;   threshhold value.  (This saves a compare
				;   in the inner loop.)
	align	4
xincloop:
	mov	al,ah
	out	dx,al		;Operate only on the current bit
        xor     al,al           ;Turn off dot's old color
	test	bh,ah		;Should we set bit ?
	jz	short xincp		;no.  skip it
	mov	al,bl		;Yes--get our current color

	align	4
xincp:
	xchg	[edi],al 	;Read/modify/write

;	Advance to next dot to right
	ror	ah,1
	adc	edi,0			;Wrap to next byte when needed
	sub	esi,rangey	;If motion in x-direction is getting
	jge	short xinc2		;   ahead of motion in y-direction,
	add	esi,rangex	;   correct relative-motion counter.
	add	edi,row_inc	;Take a step in y-direction.
	loop	xincloop
	jmp	drvx			;Done.

	align	4
xinc2:	loop	xincloop
	jmp	drvx		;Done.

;We're drawing a horizontal line.  Try for some performance optimizations.

	align	4
jlooponx:			;JUST looping on X
	cmp	bh,0FFh		;Is the line pattern "solid"
	je	short jxsolid		;Yes--Ok to optimize
	or	bl,bl		;No--Is the color non-zero?
	jnz	short looponx		;Yes--We have to do it all a bit at a time

	align	4
jxsolid:
	mov	ecx,esi
	inc	ecx		;One dot more than (x2-x1).
	or	ah,ah		;Are we starting at a byte boundary?
	js	short jxatbyte	;Yes--Skip bit-at-a-time loop

; Fill in the bits one at a time until we get to a byte boundary or the
; end of the line.
	align	4
jxincloop:
	mov	al,ah
	out	dx,al		;Operate only on the current bit
	mov	al,bl		;Get our current color (or 0 if erasing)
	xchg	[edi],al 	;Read/modify/write
	shr	ah,1		;Advance to the next dot to the right
	loopnz	jxincloop	;Loop 'til on a byte boundary or no more pixels
	jecxz	drvx		;Exit if we're all done with the horizontal line
	inc	edi		;Advance past the byte we just finished
	mov	al,0FFh		;Prepare to do full byte operations for a while
	out	dx,al		;Enable all bits of the byte for writing
	mov	ah,80h		;Set up bit mask for one bit at a time

	align	4
jxatbyte:
	mov	al,bl		;Get current color int AL for STOSB's below
	mov	bh,cl		;Isolate the 3 low order bits of the count
	and	bh,7		;	as the number of extra bits in last byte
	shr	ecx,3		;Convert remaining bit count to byte count
	test	byte ptr props, mask xormode ;Is this an XOR request?
	jnz	short jxxebyte	;Yes--We must use a slightly slower inner loop
	rep	stosb			;Store full bytes worth of our color
	mov	cl,bh		;Recover count of bits in last byte (maybe none)
	jecxz	drvx		;Return to caller if line is finished
	jmp	short jxincloop	;Go do the tail end of the line

	align	4
jxxbyte:
	cmp	al,[edi]	;Just do a Read cycle from the REGEN buffer
	stosb			;Now do a write.  (The hardware does the XOR.)
jxxebyte:
	loop	jxxbyte
	mov	cl,bh		;Recover count of bits in last byte (maybe none)
	jecxz	drvx		;Return to caller if line is finished
	jmp	short jxincloop	;Go do the tail end of the line

;Loop on y.
	align	4
loopony:
	mov	esi,ecx
	shr	esi,1
	inc	ecx
	align	4
yincl0:
	mov	al,ah
	out	dx,al		;Select the current bit

	align	4
yincloop:
        xor     al,al           ;Turn off dot's old color
	test	bh,ah		;Should we set bit ?
	jz	short yincp		;no.  skip it
	mov	al,bl		;Yes--get our current color
yincp:
	align	4
	xchg	[edi],al 	;Read/modify/write
	rol	bh,1		;Shift pattern mask one position
	add	edi,row_inc	;Take a step in y-direction.
	sub	esi,rangex	;Update relative-motion counter.
	jl	short yinc2
	loop	yincloop
	jmp	short drvx

	align	4
yinc2:
	add	esi,rangey
	ror	ah,1		;Increment x.
	adc	edi,0		;Advance to next byte when appropriate
	loop	yincl0
drvx:
	pop	ebx
	ret
drvc	endp


;we get to "remove" if a color 0 vector is drawn (erasing)
;viewport # is in ch reg (put there by wtrans)
;now we must search backwards thru display list, looking
;for the vector to be deleted. Target vector is on the stack
;in args...
;we mark a vector as erased by setting 8000h bit of X2
;

remove proc near
	mov edi,_ecurwind
	cmp [edi].overflow,0
	jnz unrem			;don't try if corrupt list
	cmp [edi].ioffset,0
	jz unrem		;can't remove if nothing in list
	mov ebx,[edi].ioffset
	mov ecx,[edi].dlist	;get display list starting address
    add ebx,ecx
	mov edi,ebx		;di to offset of end of display list
	sub ebx,2
	align 4
newy:
	cmp ebx,edi	;check for end of list
	jge unrem
	cmp ebx,ecx	;check for start of list!
	jl unrem
	mov ax,[ebx]		;we care about the flag bits!
	cmp ax,0ffffh
	jz down4
	cmp ax,y2
	jnz down2
	sub ebx,2
	mov ax,[ebx]
	cmp ax,x2
	jnz down1		;x fails to match
	mov edx,ebx		;save pointer into list
;arrive here having found the end point of the vector
;now look for start and port/color
	sub ebx,2
	mov ax,[ebx]		;we still care about this flag bit
	cmp ax,y1
	jnz portck		;better be port/col or this is wrong!
	sub ebx,2
	mov ax,[ebx]
	and ax,7fffh		;mask off move-only bit
	cmp ax,x1
	jnz up1			;x fails to match, back up and see
				;if this might be start
;fall into here having, for sure, found the vector
	align 4
gdv:	mov ebx,edx
	or [ebx],8000h	;set "moveonly" flag bit
	align 4
unrem:	
	ret
;still looking for start point, but may have hit port # flag
	align 4
portck:	cmp ax,0ffffh
	jnz newy		;this can't be our vector
	sub ebx,2		;check port only (ignore color)
;ok port, now check start point
	sub ebx,2
	mov ax,[ebx]
	cmp ax,y1		;we care about flags here (hilight)
	jnz down2
	sub ebx,2
	mov ax,[ebx]
	and ax,7fffh		;ignore moveonly flag
	cmp ax,x1
	jnz down1
	jmp gdv
	align 4
down4:	sub ebx,2
	align 4
down3:	sub ebx,2
	align 4
down2:	sub ebx,2
	align 4
down1:	sub ebx,2
	jmp newy
	align 4
up1:	add ebx,2	;back up, this may be the start of something
	jmp newy
remove endp


append proc near
;append a vector to the display list (if there is room for it)
;if we already know that's impossible (overflow=1), forget it.
;enter with 256*port + color in cx
	mov edi,_ecurwind
	cmp [edi].overflow,0

	jnz forgetit

	mov eax,[edi].ioffset
	cmp eax,(100 * 1024) -50
	jb notfull
	mov _overflow,1
	mov [edi].overflow,1
	ret
	align 4
notfull: 
	mov eax,[edi].dlist
	mov ebx,[edi].ioffset
   	add ebx,eax
	mov edx,ebx
	sub edx,2
	cmp [edi].ioffset,0
	jz fresh		;this is a fresh start of "moveonly"
	align 4
notfresh:
;check last vector in list to see if this is a continuation
	mov ebx,edx	;save end of list position
	mov ax,[ebx]
	cmp ax,y1	;"from Y"
	jnz fresh
	sub ebx,2
	mov ax,[ebx]
	cmp ax,x1   ;"from X"
	jnz fresh
	;now go back to search for ffffh, then
	;we've found the viewport/color word
	align 4
ptl:	add ebx,-2
	cmp word ptr [ebx],0ffffh
	jnz ptl
	add ebx,-2
	mov ax,[ebx]		;must be same color
	cmp al,cl
	jnz fresh
	mov ax,x2
	mov ebx,edx
	mov [ebx+2],ax	;"to X"
	mov ax,y2
	align 4
nothi0:	mov [ebx+4],ax	;"to Y"
	mov eax,4
	add eax,[edi].ioffset
	mov [edi].ioffset,eax	;bump inlist pointer by # words used
	align 4
forgetit: 
	ret
	align 4
fresh:	;arrive here if we have to start a fresh vector sequence
	mov ebx,edx
	mov ax,x1
	or ax,8000h	;turn on moveonly flag
	mov [ebx+2],ax
	mov ax,y1
	mov [ebx+4],ax
	mov [ebx+6],cx	;port & color
	mov word ptr [ebx+8],0ffffh	;flag
	mov ax,x2
	mov [ebx+10],ax
	mov ax,y2
	align 4
nothi:	mov [ebx+12],ax
	mov eax,12
	add eax,[edi].ioffset
	mov [edi].ioffset,eax
	ret
append endp


	align 4
wtrans proc near
	;translate vpnumber 1-255 -> physical number 1-16
	;to correspond to the 16 vpinfo structures
	;vpnumber is in ax on entry
	;exit with physical port # in ch reg
	; = 17 if bad vpnumber
	push edi
	push esi
	mov cx,ax
	cmp ax,0
	jz badwind
	mov _targetv,ax
	mov esi,offset _wtranv ;1st result location
	mov edi,offset _vpinfo	;1st vpinfo block
	mov ch,1
	align 4
nextwind: push ax
	mov ax,[edi]
	mov [esi],ax
	add esi,2
	pop ax
	cmp ax,[edi]
	jz thiswind
	inc ch
	cmp ch,17
	jz badwind
	add edi,SIZE wstat
	jmp nextwind
	align 4
badwind: mov edi,0
        mov _overflow,2 ;flag error
	align 4
thiswind: mov _chreg,ch
 	mov _ecurwind,edi
        pop esi
	pop edi
	ret
wtrans endp

;strans is like wtrans except it finds a slave vpinfo structure
;with index from 17-31, used for viewports which are a subset of
;another viewport. enter with vpnumber in AX
	align 4
strans proc near
	push edi
	mov cx,ax
	cmp ax,0
	jz badvp
	mov edi,offset _vpinfo	;1st vpinfo block
	add edi,(SIZE wstat)*16		;bump to 17th block
	mov ch,17
	align 4
nextvp: cmp ax,[edi]
	jz thisvp
	inc ch
	cmp ch,32
	jz badvp
	add edi,SIZE wstat
	jmp nextvp
	align 4
badvp: mov edi,0
	mov _overflow,3 ;flag error
	align 4
thisvp: mov _ecurwind,edi
	pop edi
	ret
strans endp

comment	@
	eiclip(x1,y1, x2,y2)

	This routine is	called with a vector in	logical space and
	transforms and clips it	to the actual screen display viewport.
	The result is zero if the vector is totally off	screen (and
	hence need not be displayed), and nonzero if a vector is
	returned to be displayed.  The clipped,	transformed vector is
	left in	(x1, y1) and (x2, y2).  

	enter with ecurwind initialized by wtrans     @

	align 4
eiclip	proc	near

	mov	edi,_ecurwind	; Load in the current viewport descriptor
	cmp	edi,0
	jz	ic9		;forget it if we didn't find viewport
	align 4
ic2:
;       Determine off-screen bits for "to" end of vector (x2,y2):
;	1 if off to left
;	2 if off to right
;	4 if off to bottom
;	8 if off to top
	mov	ebx,0
	xor	al,al		; Assume on screen.
	mov	bx,y2
	mov	cx,bx		; Copy y2 to bx.
	cmp	[edi].lgyh,bx
	rcl	al,1		; Carry=1 if offscreen top.
	cmp	bx,[edi].lgyl
	rcl	al,1

	mov	bx,x2
	or	cx,bx		; (y2 OR x2) to	cx.
	cmp	[edi].lgxh,bx
	rcl	al,1
	cmp	bx,[edi].lgxl
	rcl	al,1

	mov	os2,al

;	Special	test if	any coordinate is negative.  If	it is, we
;	exit immediately to prevent divide overflows (this is in
;	lieu of	putting	a JO instruction after each of the eight
;	compares of the	coordinates with the clip boundaries).

        or      cx,x1           ; That's (y2 OR x2 OR x1)
	or	cx,y1
	js	ic9		; Somebody was negative.

;	Start of main loop which iterates, clipping vector until
;       it's either wholy inside or wholy outside of box.
	align 4
ic5:

;	Get off-screen bits for	(x1,y1).

	xor	al,al		; Assume on screen.
	mov	bx,y1
	cmp	[edi].lgyh,bx
	rcl	al,1
	cmp	bx,[edi].lgyl
	rcl	al,1

	mov	bx,x1
	cmp	[edi].lgxh,bx
	rcl	al,1
	cmp	bx,[edi].lgxl
	rcl	al,1

	mov	ah,os2		; (x2,y2) bits again.
	test	al,ah		; If both ends offscreen
	jz	ic10		;   in same direction,
	align 4
ic9:	xor	ax,ax		;   whole vector is off.
	ret			; Return failure.
	align 4
ic10:	test	al,al		; If clipped (x1,y1)
	jnz	ic12		;   is offscreen, go clip again.
	test	ah,ah		; If (x2,y2) is	onscreen,
	jnz	ic11
	jmp	ic14		;   success.
	align 4
ic11:

;	Swap endpoints so (x1,y1) is offscreen and go clip again.

	mov	os2,al
	mov	bl,ah		; New (x1,y1) offscreen	bits.
	mov	ax,x1
	xchg	ax,x2
	mov	x1,ax
	mov	ax,y1
	xchg	ax,y2
	mov	y1,ax
	jmp	ic13


;	Both ends outside of viewport, vector may	or may not cross the
;       viewport.  Clip "from" end and test again.
	align 4
ic12:
	mov	bl,al		; Offscreen bits for (x1,y1)
	align 4
ic13:
	xor	bh,bh		;   to bx.
	shl	bx,2
	jmp	cs:icjtab[ebx]
	align 4
icjtab	dd	ic9,icas1,icas2,ic9
	dd	icas4,icas5,icas6,ic9
	dd	icas8,icas9,icas10,ic9
	dd	ic9,ic9,ic9,ic9
	align 4
icas1:				; Off left edge.
;	      y1 += ((y2-y1)*(lgxl-x1))/(x2-x1);
;	      x1=lgxl;

	mov	cx,y1
	mov	si,x1
	mov	ax,y2
	sub	ax,cx
	mov	bx,[edi].lgxl
	mov	x1,bx
	sub	bx,si
	imul	bx
	mov	bx,x2
	sub	bx,si
	idiv	bx
	add	cx,ax
	mov	y1,cx
	jmp	ic5
	align 4
icas2:				; Off right edge.
;	      y1 += ((y2-y1)*(lgxh-x1))/(x2-x1);
;	      x1=lgxh;

	mov	cx,y1
	mov	si,x1
	mov	ax,y2
	sub	ax,cx
	mov	bx,[edi].lgxh
	mov	x1,bx
	sub	bx,si
	imul	bx
	mov	bx,x2
	sub	bx,si
	idiv	bx
	add	cx,ax
	mov	y1,cx
	jmp	ic5

	align 4
icas4:				; Off bottom edge.
icas5:
icas6:
;	      x1 += ((x2-x1)*(lgyl-y1))/(y2-y1);
;	      y1=lgyl;

	mov	cx,x1
	mov	si,y1
	mov	ax,x2
	sub	ax,cx
	mov	bx,[edi].lgyl
	mov	y1,bx
	sub	bx,si
	imul	bx
	mov	bx,y2
	sub	bx,si
	idiv	bx
	add	cx,ax
	mov	x1,cx
	jmp	ic5
	align 4
icas8:				; Off top edge.
icas9:
icas10:
;	      x1 += ((x2-x1)*(lgyh-y1))/(y2-y1);
;	      y1=lgyh;

	mov	cx,x1
	mov	si,y1
	mov	ax,x2
	sub	ax,cx
	mov	bx,[edi].lgyh
	mov	y1,bx
	sub	bx,si
	imul	bx
	mov	bx,y2
	sub	bx,si
	idiv	bx
	add	cx,ax
	mov	x1,cx
	jmp	ic5


;       Come here if we're successful.
	align 4
ic14:
ic15:
;	Scale to physical coordinates:
ic16:
	mov	ax,x1
	sub	ax,[edi].lgxl
	mul	[edi].wixdots
	div	[edi].vxdots
	add	ax,[edi].vpxmin	;add viewport offset
	mov	x1,ax

	mov	ax,y1
	sub	ax,[edi].lgyl
	mul	[edi].wiydots
	div	[edi].vydots
	add	ax,[edi].vpymin
	mov	bx,word ptr _aybias
	sub	bx,ax		;flip Y coord
	mov	y1,bx

	mov	ax,x2
	sub	ax,[edi].lgxl
	mul	[edi].wixdots
	div	[edi].vxdots
	add	ax,[edi].vpxmin
	mov	x2,ax

	mov	ax,y2
	sub	ax,[edi].lgyl
	mul	[edi].wiydots
	div	[edi].vydots
	add	ax,[edi].vpymin
	mov	bx,word ptr _aybias
	sub	bx,ax		;flip y coord
	mov	y2,bx

	mov	ax,1
	ret			; Return success.

eiclip	endp


	align 4
fclip	proc near
	call	eiclip		;clipping
	cmp	ax,1		;a non-0 viewport vector properly clipped
	jnz	baddv		;skip drawing if bad or offscreen
	align 4
goodv:  
	push ebp
	call	drvc
	pop ebp
	mov ax,1
	align 4
baddv:	ret
fclip	endp


	subttl	External Routines

;***************************** EXTERNAL ROUTINES ***************************

;_initpal is called in gograph() to set up the ega/vga pallete properly
;so that color xor dragging will work. Xenix resets the pallete on every
;mode change.
	align 4
_initpal proc near
	push esi
	push edx
	push ebx

	mov esi,offset pallete
	mov ebx,15

	cli

	mov edx,03dah	;status register 1
ip1:	in al,dx
	test al,8	;are we in vertical retrace?
	jnz ip1		;yes
ip2:	in al,dx
	test al,8
	jz ip2		;wait until another starts

	mov edx,03c0h	;attribute register
ip3:	mov al,bl
	out dx,al
	mov al,[esi+ebx]
	out dx,al
	dec ebx
	jns ip3

	mov al,20h
	out dx,al	;turn video back on

	sti

	mov edx,03bah
	in al,dx

	pop ebx
	pop edx
	pop esi
	ret
_initpal endp


;vtran is called from C to translate a viewport #,
;gets called once at start of redraw for each viewport,
;sets up ecurwind for ICLIP.
	align 4
_vtran:
vtran proc near
	push ebp
	mov ebp,esp
	mov eax,args	;vpnumber
	call wtrans	;this also leaves ecurwind initialized for eiclip
	mov ah,ch
	and eax,0ff00h	;256 * translated # into ax
	pop ebp
	ret
vtran endp

	align 4
_svtran:
svtran	proc near
	push ebp
	mov ebp,esp
	mov eax,args	;vpnumber
	call strans	;this leaves ecurwind initialized for eiclip
	mov al,ch
	and eax,0ffh	;translated # into ax
	pop ebp
	ret
svtran endp

;	To append or remove a vector from (x1,y1) to (x2,y2):
;	without drawing it (background mode!)
;
;	    call luvec(x1, y1, x2, y2, property, viewport);
;
;LUVEC appends or removes only
	align 4
_luvec:
luvec proc near
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx

	mov	eax,args+20 ;was 10	;get vpnumber
	call wtrans		;viewport translation
	mov ecx,args+16 ;was 8		;get translated color

	mov	al,cl
	and	al,78h
	cmp	cl,_bgc		;are we erasing?
;	jnz	luner
;	call remove		;remove from display list
;	jmp	uvecret
	align 4
luner:	call	append		;add to display list
	align 4
uvecret:
	pop	ebx
	pop	edi
	pop	esi
	pop	ebp
    ret
luvec	endp



;	To draw a vector from (x1,y1) to (x2,y2):
;
;	    call slvec(x1, y1, x2, y2, property);
;
; slvec handles logical vectors by clipping, scaling
;	and drawing them - used by redraw
;	enter with ecurwind initialized already
	align 4
_slvec:
slvec proc near
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx

	call	fclip		;transform & scale data
	cmp	ax,1
	jnz	usret
	jmp	vecret		;use exit code from ADSVEC
	align 4
usret:
	pop	ebx
	pop	edi
	pop	esi
	pop	ebp
	ret	
slvec	endp


;	To draw a vector from (x1,y1) to (x2,y2):
;
;	    call lvec(x1, y1, x2, y2, property, viewport);
;
;LVEC appends or removes, clips & draws with slaves & master vp
	align 4
_lvec:
lvec proc near
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx

	mov	eax,args+20 ; was10	;get vpnumber
	call wtrans		;viewport translation
	mov ecx,args+16 ;was 8		;get translated color
	align 4
comvec:
	mov	al,cl
	and	al,78h
	cmp	cl,_bgc		;are we erasing?
;	jnz	ner
;	call remove		;remove from display list
;	jmp	icit
	align 4
ner:	call	append		;add to display list
	jmp	icit
lvec	endp

_fdraw proc near
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx
	mov	eax,args+24	;get vpnumber
	call	wtrans
	mov	eax,args+16	;color
	movsx	ax,byte ptr _ltop[eax+18]
	shl	ax,3		;convert color to prop
	mov	ecx,eax
	jmp short comvec
_fdraw endp


;
;	To draw a vector from (x1,y1) to (x2,y2):
;
;	    call rlvec(x1, y1, x2, y2, property, viewport);
;
;RLVEC clips & draws slaves as well as master
	align 4
_rlvec:
rlvec	proc	near
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx

	align 4
icit:	;now check to see if this vector is from a master
	;viewport
	mov	edi,_ecurwind
	cmp	edi,0
	jnz	okv
	jmp	vecret		;if bogus viewport
	align 4
okv:	mov	ax,[edi].slaves	;holds a count of # slave vps
	cmp	ax,0
	jnz	ysl
	jmp	notm		;if no slave viewports
	align 4
ysl:
;fall into here if there are slave viewports to be considered
;1st preserve logical coords

	mov	ax,x1
	mov	sx1,ax
	mov	ax,y1
	mov	sy1,ax
	mov	ax,x2
	mov	sx2,ax
	mov	ax,y2
	mov	sy2,ax
	call	fclip		;draw master vector
	mov	edi,_ecurwind
	mov	ax,[edi].vpnumber	;fetch raw vp number
	mov	target,ax		;master vp number
	mov	moff,0
	align 4
masta:	mov	edi,0
    mov di,moff
	add	edi,offset _vpinfo
	mov	ax,[edi].master
	cmp	ax,target		;right master?
	jz	hits
	align 4
miss:	mov	ax,SIZE wstat
	add	moff,ax
	cmp	moff,(SIZE wstat) * 16	;look thru every viewport
	jnz	masta
	jmp	vecret

	align 4
hits:	;found a slave for this master, now find slave data structure

	mov	ax,[edi].vpnumber	;slave's vpnumber
	mov	svp,ax
	mov	edi,(SIZE wstat) * 16
	mov	toff,edi
	align 4
slav:	mov	edi,offset _vpinfo
	add	edi,toff
	mov	_ecurwind,edi
	mov	ax,[edi].vpnumber
	cmp	ax,svp
	jnz	nots

	mov	ax,sx1
	mov	x1,ax
	mov	ax,sy1
	mov	y1,ax
	mov	ax,sx2
	mov	x2,ax
	mov	ax,sy2
	mov	y2,ax		;restore logical vector
	call	fclip
	jmp	miss
	align 4
nots:
	mov	eax,SIZE wstat
	add	toff,eax
	cmp	toff,(SIZE wstat) * 32
	jnz	slav
	jmp	miss

	align 4
notm:
	call	eiclip		;clipping
	cmp	ax,1		;a non-0 viewport vector properly clipped
	jnz	badumv		;skip drawing if bad or offscreen
	push ebp
	call	drvc
	pop ebp
	jmp	vecret
	align 4
badumv:				;use this exit if no vector drawn
	pop	ebx
	pop	edi
	pop	esi
	pop	ebp
	ret	
rlvec	endp


;	To draw a vector from (x1,y1) to (x2,y2):
;
;	    call adsvec(x1, y1, x2, y2, property);
;
;	See comments at the top of this file for a definition
;       of the "properties" argument.  Note that requests for
;	XORMODE in background color tend to do nothing, slowly.
;
	align 4
_tadsvec:
ADSVEC	proc	near
	push	ebp
	mov	ebp,esp		;Make ourselves a stack frame.
	push	esi
	push	edi
	push	ebx

	call	drvc		;common drawing routine

;** common exit routine used by  vector routines
	align 4
vecret:
	pop	ebx
	pop	edi
	pop	esi
	mov	dx,GCHIP+1
	mov	al,0FFh
	out	dx,al		;Restore bit mask select
	dec	dx
	OUT_DX	G_MODE,0
	test	byte ptr props, mask xormode
	jz	short vecret2
	OUT_DX	G_DATA_ROT,REP_MODE
vecret2:
	pop	ebp
	ret	
ADSVEC	endp


;=======================================================================
;       Autodesk user interface support routines


;       Draw a raster cursor at a specified location

;       egacur(xpos, ypos, lines)
	align 4
_egacur:
EGACUR  proc    near
        push    ebp
        mov     ebp,esp
        push    esi
        push    edi
	push	ebx
        mov ebx,0
        mov eax,0
        EGADOT x1,y1 ;start address in map
        mov     ax,3            ; load standard copy count
        or      cl,cl           ; odd bit ?
        jnz     dscur4          ; yes.
        dec     ax              ; even.  two byte operation
	align 4
dscur4: mov     cureven,ax      ; save bit offset

        mov     curspos,ebx      ; save for restore
        mov     cx,args+8       ; load lines to process
        mov     curline,cx      ; save it for restore
        mov     esi,0		; load and mask
        mov     edi,0		; load xor mask

	push	esi		; offset in AND mask
	push	edi		; offset in XOR mask
	push	ebx		;# row start address
	push	cx		;# rows to process

        mov     ax,cureven      ; reload even flag
        mov     ah,al           ; save in AH

;this loop will save the area covered by the cursor
;don't trash ah by using out_dx!
	mov	dx,GCHIP
	mov	al,05
	out	dx,al
	inc	dx
	mov 	al,01h	;write mode 1
	out	dx,al

	mov     ebp,cursave 	; get save buffer start
	add ebp,_vidbuf	
	align 4
dscur1:
	push	ebx		;# save row start address

    mov     al,[ebx]      ; load byte from video RAM
    mov     [ebp],al      ; save in buffer
    inc     ebx

        mov     al,[ebx]      ; load byte from video RAM
        mov     [ebp+1],al    ; save in buffer
        inc     ebx

        cmp     ah,2            ; third byte needed ?
        jz      dscur3          ; no.

        mov     al,[ebx]      ; load byte from video RAM
        mov     [ebp+2],al    ; save in buffer

	align 4
dscur3:	mov	al,0
	xchg	ah,al
    add     ebp,eax		; increment to next line in save buffer
	xchg	ah,al

	pop	ebx
	add	ebx,80		;Bump row start address.
	loop    dscur1          ; loop for all rows

;then another loop to draw in the cursor, using ega's normal mode
;and bitmask for anding

	pop	cx
	pop	ebx	;recover pointers for and loop
	pop	edi
	pop	esi
	push	esi	;save 'em  again for xor loop
	push	edi
	push	ebx
	push	cx

;still need to preserve ah reg
	mov	dx,GCHIP
	mov	al,05
	out	dx,al
	inc	dx
	mov	al,00h
	out	dx,al	;back to ega write mode 0

;get ready for setting and mask into ega bitmask reg
	mov	dx,3ceh
	mov	al,8		;register 8
	out	dx,al		;is bit mask register
	inc	dx

	align 4
xl1:	push	ebx
	mov	al,_curam[esi+2]	;fetch AND mask
	not	al		;flip bits
	out	dx,al
	mov	al,[ebx]	;fetch byte from ega ram
	mov	[ebx],byte ptr 0	;turn off pixels

	inc	ebx

	mov	al,[ebx]
	mov	al,_curam[esi+1]
	not	al
	out	dx,al
	mov	[ebx],byte ptr 0

	inc	ebx

	cmp	ah,2		;third byte needed?
	jz	xl3

	mov	al,[ebx]
	mov	al,_curam[esi]
	not	al
	out	dx,al
	mov	[ebx],byte ptr 0

	align 4
xl3:	add	esi,4
	add	edi,4
	pop	ebx
	add	ebx,80		;bump to next row
	loop	xl1		;until out of rows

	pop	cx
	pop	ebx		;recover pointers for xor loop
	pop	edi
	pop	esi

	mov	dx,GCHIP
	mov	ax,03
	out	dx,al
	inc	dx
	mov	al,18h
	out	dx,al		;xor mode

;get ready for setting xor mask into ega bitmask reg
	mov	dx,3ceh
	mov	al,8		;register 8
	out	dx,al		;is bit mask register
	inc	dx

	align 4
xo1:

	push	ebx
	mov	al,[ebx]	;latch ega data
	mov	al,_curxm[edi+2]	;xor mask
	out	dx,al
	mov	[ebx],byte ptr 0ffh	;xor pixels

	inc	ebx

	mov	al,[ebx]
	mov	al,_curxm[edi+1]
	out	dx,al
	mov	[ebx],byte ptr 0ffh

	inc	ebx

	cmp	ah,2		;third byte needed?
	jz	xo3

	mov	al,[ebx]
	mov	al,_curxm[edi]
	out	dx,al
	mov	[ebx],byte ptr 0ffh	

	align 4
xo3:	add	esi,4
	add	edi,4
	pop	ebx
	add	ebx,80		;bump to next row
	loop	xo1		;until out of rows

	mov	dx,GCHIP
	OUT_DX	08h,0ffh
	OUT_DX	03h,00h
	;bit map all 8 bits
	;turn off xor mode
	;restore normal ega status
	pop	ebx
        pop     edi
        pop     esi
        pop     ebp
        ret
EGACUR  endp

;       Restore area covered by raster cursor

;       egaccur()
	align 4
_egaccur:
EGACCUR proc    near
        push    ebp
        mov     ebp,esp
        push    esi
        push    edi
	push	ebx

	mov	dx,GCHIP
	OUT_DX	05h,01h

        mov esi,0
	mov ecx,0
        mov     ebx,curspos      ; load bitmap start address
        mov     dx,curline      ; load lines to restore
        mov     si,cursave	    ; get cursor save buffer offset
        add esi,_vidbuf
        cld                     ;Increment.
        mov     bp,cureven
	align 4
dscuc1: mov     cx,bp           ; load byte count
        mov     edi,ebx           ; load RAM start address
        rep     movsb           ; restore data to video RAM

        add     ebx,80		;Bump row start address.
	    dec     dx              ; all lines done ?
        jg      dscuc1          ; no.  keep on going


	;restore ega write mode 0
	mov	dx,GCHIP
	OUT_DX	05h,00h

	pop	ebx
        pop     edi
        pop     esi
        pop     ebp
        ret
EGACCUR endp


 
;	adsdot(x,y)
;
;	Draw a dot at screen coordinates (x,y)
;
dotcolor	equ	15	; Color to draw the dot in (in XOR mode)

;x	equ	args	
;y	equ	args+4

	align	4
_tadsdot:
_adsdot	proc	near
	push	ebp
	mov	ebp,esp
	push	ebx

;------ Determine the REGEN byte address

	mov	eax,_aybias	;Convert AutoCAD Y co-ordinate to EGA format
	sub	eax,y1
	mov	y1,eax
	EGADOT	x1,y1

	;From here on, EBX is the byte address and CL is the bit shift count

;------ Set the desired drawing mode

	mov	dx,GCHIP
	mov	al,G_DATA_ROT
	out	dx,al
	inc	edx
	mov	al,XOR_MODE
	out	dx,al

;------ If we are XOR'ing with the constant 15, we can optimize some.

  if	dotcolor EQ 15

	mov	al,80h
	shr	al,cl		;Get the bit we want to diddle
	xchg	[ebx],al 	;Do the deed
	mov	al,REP_MODE	;Restore normal writing mode
	out	dx,al

	pop	ebx
	leave
	ret

  else

;------ Write to the EGA using write mode 2.

	dec	edx
	OUT_DX	G_MODE,2

;------ Determine the bit within the byte and set the appropriate mask

	mov	al,G_BIT_MASK
	out	dx,al
	inc	edx
	mov	al,80h		;Uppermost bit of al
	shr	al,cl		; and rotate as many as necessary
	out	dx,al		;Send it to the EGA

	mov	al,dotcolor
	xchg	[ebx],al 	;Latch data and flip bits

;------ Restore caller's and EGA's environment

;------ Restore Bit Mask register
	mov	al,0FFh
	out	dx,al		
	dec	edx

;------ Set WRITE MODE 0
	OUT_DX	G_MODE,0

;------ Restore function to simple replace
	OUT_DX	G_DATA_ROT,REP_MODE

	pop	ebx
	leave
	ret

  endif
_adsdot	endp


;	Routine to copy a block of BYTES from one place to another.
;	Normally, either the source or the destination or both are
;	in the REGEN.  The source and/or destination can be
;       "unraveled" during the copy.  For example, you could copy
;	a rectangular region into a linear array.  All operations
;	occur on byte boundaries.  There is a special case for
;	moves from one place in the buffer to another which moves
;	more than one plane at a time.
;
;	byteblt(dest, source, width, height, dest_inc, source_inc,
;		write_map_mask, read_map_number);
;
;	source	is the address of the first source byte. 
;	dest	is the address of the first target byte.
;       width   is the width of the box being moved in bytes.  (It's not
;               unusual for "width" to be more bytes than one raster
;               line on the screen when processing "boxes" that are the
;		full width of the screen.)
;	height	is the height of the box being moved in bytes.
;	dest_inc is the number of bytes to advance the destination pointer
;		between rows of the box.
;	source_inc is the number of bytes to advance the source pointer
;		between rows of the box.
;	write_map_mask is a mask of bits indicating which plane(s) in
;		the destination should receive data.
;	read_map_number is the number of the plane from which data is
;               to be read.  A special case value of "-1" indicates that
;		data from multiple planes is to be moved.  This only
;		works if both source and dest are in the REGEN buffer
;		of course!
;
;	This function is used for several purposes:
;
;       o  It can be used to scroll data when "read_map" is -1.
;	   For example:
;
;		 byteblt(0, graphseg, 16*80, graphseg, 20, 32, 80-20, 80-20,
;			 0x0F, -1);
;
;	   would move the block whose upper left corner was at pixel
;	   location (0,16) and whose lower right corner was at (159,47) to
;	   the upper left corner of the display. 
;
;       o  It can be used to copy a single map's data to a different
;	   location, either into some totally separate buffer or
;	   into a different part of the REGEN buffer, possibly on
;	   a different plane.
;
;	o  It can be used to copy data from a buffer into the REGEN
;	   buffer.
;

desta	equ	args+0
SRC	equ	args+4
wid	equ	args+8
HEIGHT	equ	args+12
DST_INC	equ	args+16
SRC_INC	equ	args+20
W_MAP	equ	args+24
R_MAP	equ	args+28

	align	4
_tbyteblt:
_byteblt proc	near
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx

;------ Set up the S_MAP register to select which planes we're writing in

	mov	dx,SCHIP
	mov	al,S_MAP
	out	dx,al
	inc	edx
        mov     al,W_MAP	; Get output maps' selection
	out	dx,al

;------ For copying all planes, we want to be in write mode 1.	For a
;------ single plane, we want that plane set in the READ_MAP.

	mov	dl,GRAPH_ADDR
	mov	al,G_READ_MAP	; Assume we will read from some one map
	mov	ah,R_MAP	; Get read map value (or -1 for all planes)
        xor     bl,bl           ; (restore to zero when we're all done)

	cmp	ah,0FFh 	; Special request to copy all maps?
	jne	short blt1	; No--Go copy one map to desired target map(s)
	mov	al,G_MODE	; Yes--Change our desired write mode
	mov	ah,1	;	to 1.
        mov     bl,0      ; Restore it to zero when we're done copying
	align	4
blt1:	out	dx,al		; Select the desired map or write mode
	inc	edx
	mov	al,ah
	out	dx,al

;------ Pick up arguments which locate the data

	mov	esi,SRC	; Get source byte address
	mov	edi,desta	; Get destination byte address

;------ Do the actual copy
; At this point:
;	BL	has the value to restore into the currently selected graphics
;		chip register.
;	ESI	has the initial source address
;	EDI	has the initial destination address

	push	ebx
	mov	eax,HEIGHT ; Get number of rows to process
	or	eax,eax
	jz	short blt3	; Zero rows is easy enough

	mov	edx,SRC_INC ; Get source pointer row increment
	mov	ebx,DST_INC ; Get destination pointer row increment
	align	4
blt2:	mov	ecx,wid
	; Get byte transfer count for one row
	rep	movsb		; Copy the data byte by byte for one row
	add	esi,edx		; Increment the source pointer
	add	edi,ebx		; Increment the destination pointer
	dec	eax
	jnz	short blt2	; Loop for all rows

;------ Restore EGA Registers to standard values

	align	4
blt3:	pop	eax
	mov	dx,GCHIP+1
	out	dx,al		; Restore the desired map or write mode
	dec	al		; ?????????

;------- Restore the S_MAP register
	mov	dl,SEQ_ADDR
	OUT_DX	S_MAP,0Fh

;------ Restore caller's state and return
	pop	ebx
	pop	edi
	pop	esi
	leave
	ret
_byteblt endp


;	Routine to draw a glyph (character, icon or box) at specified
;	coordinates:
;
;	       adsglyph(x, y, deltax, deltay, properties, &buf);
;
;       The glyph box is "deltax" wide by "deltay" high, of which (x,y)
;       is the upper left corner.  The "buf" is the address of a
;	memory buffer containing an image of the glyph.  The
;       representation of each row's worth of data takes an integral
;	number of bytes.  (Any low-order slack bits in the last byte
;	of a buffer row MUST be zero.)	The buffer should have a one
;	for parts of the glyph and a 0 for parts of the background.
;	If buf is a NULL pointer, then adsglyph operates as if it
;	pointed to a buffer full of one bits.  This is useful for
;	manipulating rectangular regions of the screen.
;
;       "Properties" argument is as described at the top of this file.
;
;	buf is a four-byte (long) pointer, i.e., it consists of an
;	offset and a segment.
;

;xp	equ	 args
;yp	equ	 args+4
deltax	equ	 args+8
deltay	equ	 args+12
props	equ	 args+16
buf	equ	 args+20



	align	4
_tadsglyph:
_adsglyph proc	near
	push	ebp
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx

;	The following code very closely parallels the beginning of
;	routine adsvec.  See the comments there for explanations of
;	the slight differences.
	mov	ebx,props	;Get properties
	mov	dx,GCHIP	;Set up to load GRAPHICS chip registers
	xor	edi,edi
	mov	shiftcnt,edi ;Set highlight mask shift count to 0
	dec	edi		;Get an all ones mask for pattern
	mov	cl,bl		;Copy most property bits
	shr	ebx,mcolor
	and	ebx,(mask mcolor) shr mcolor
	mov	ch,bl ;Get translated color
	test	cl,(mask xormode) or (mask hilite)
	jz	short dsgly2	;No special modes
	test	cl,mask xormode ;Is this an XOR request?
	jz	short dsgnoxor
	or	ch,ch		;Are we about to try to do XOR in black?
	jnz	short gnotblack	;No
	xor	ebx,ebx
	or	ch,0 ;Try color zero for non-black
	jnz	short gnotblack
	mov	bl,15
	or	ch,15 ;Try color 15
	jnz	short gnotblack
	mov	bl,7
	or	ch,7 ;Use color 7
	align	4
gnotblack:
	OUT_DX	G_DATA_ROT,XOR_MODE	;Yes--Set function to XOR mode
	test	cl,mask hilite	;Is the icon to be highlighted too?
	jz	short dsgly2	;No.
	align	4
dsgnoxor:
	mov	di,GREY1	;Yes--load grey mask 1
	mov	al,y1	;Get low-order bits of initial Y
	inc	dword ptr shiftcnt ;Bump the shift count
	test	cl,(mask hilite) and ((mask hilite) - 1)
	jz	short dsgly1	;Level one highlighting?
	mov	di,GREY2	;No--a little less grey
	inc	dword ptr shiftcnt ;Bump the shift count again
	add	al,al		;Double the adjustment
	and	bl,7		;GREY2 always implies INTENSE
	mov	ah,bl
	or	ah,ah		;unless the INTENSE version happens to be black
	jz	short dsgly1
	mov	ch,ah
        ;Calculate the initial shift of the pattern.  We've already
	;multiplied the low order bits of the initial Y by the number of
	;pattern mask shifts per cycle in AL.
	align	4
dsgly1: and	al,15		;Shift the highlighting mask to compensate
	mov	cl,al		;	for starting other than at the top
	rol	di,cl		;	of the screen
	align	4
dsgly2: 
	OUT_DX	G_SET_RESET,ch	;Set desired color
	OUT_DX	G_ENBL_SET,0Fh	;Set all mode 0 writes to use this data

	; Set up so that we can address video RAM via EBX]
	EGADOT	x1,y1	;Locate corner in video ram in EBX. 
				;	shift count is in cl.
	mov	esi,buf		;Pointer to the icon buffer (or NULL)
	mov	al,G_BIT_MASK	;Following accesses go to G_BIT_MASK register
	out	dx,al		;Set Graphic chip pointer
	inc	edx		;Point at Graphic chip data port

;   At this point:
;	DI has the pattern mask.
;	shiftcnt is the pattern mask shift count (for each scan line)
;	EBX points to correct byte of REGEN buffer
;	CL is shift count to position icon data for each REGEN buffer byte
;	ESI points to the ICON data buffer (**NOT TO THE DATA SEGMENT**)
;	DX has the graphics chip data port (and the chip is ready to access
;		the G_BIT_MASK register)
;	Only AX and CH are available.

	or	esi,esi		;Is there an icon buffer?
	jnz	short dsgly6		;Yes--Go use it

;	NULL pointer to ICON data--Use all one bits for ICON data
	mov	esi,ebx
	mov	eax,deltax ;Get deltax

;	Get the number of complete bytes plus one of a row of graphics
;	area in ch, a mask for the (possibly) incomplete first byte in
;	bl and a mask for the (possibly) incomplete last byte in bh.
;
	movzx	ebx,cl		;Preserve cl value someplace
	; We now do two calculations simultaneously--they share some
	; intermediate results.  We want to calculate:
	; 1. NFBPO, the number of full bytes plus one, and
	; 2. NBILB, the number of bits in the last byte.
	; If either the first or the last byte is full, we treat it
	; as if it were only partially full, but with a mask that
	; accepts all of it.
	; NFBPO =  (starting_bit + number_of_bits - 1) / 8
	; NBILB = ((starting_bit + number_of_bits - 1) mod 8) + 1
	add	eax,ebx		;Adjust dot count by bit # in starting byte
	dec	eax		;eax = start bit + bit count - 1
	mov	cl,al		;Compute number of bits in last byte - 1 (0-7)
	and	cl,111b
	shr	eax,2		;Finish computing the number of full bytes + 1
	mov	ah,80h
	sar	ah,cl		;Compute mask for odd byte at end
	mov	cl,bl		;Restore input cl value (shift count)
	mov	ch,al		;Copy number of full bytes plus one
	mov	al,11111111b	;Calculate starting byte mask
	shr	al,cl		;	in al
	shr	ch,1		;Is the entire row within one byte?
	jnz	short rowmask2	;No
	and	ah,al		;Yes--Both masks need adjustment
	mov	al,ah		;	by intersecting their included bits
	align	4
rowmask2:
;
	mov	rowmask,eax ;Save first/last byte masks
	mov	cl,byte ptr shiftcnt ;Patterm mask shift count
;At this point:
;	rowmask has the first and last byte masks of a row
;		for the REGEN buffer
;	ESI has REGEN buffer start of current row
;	EBX will be used as current REGEN buffer pointer
;	DI has pattern mask
;	CL has shift count for the pattern mask (for each new row)
;	CH has REGEN buffer full bytes plus one for a row
;	deltay has remaining number of rows
;	DX has the graphics chip data port (and the chip is ready to access
;		the G_BIT_MASK register)

;	Start a new row
	align	4
dsgly4: mov	al,byte ptr rowmask ;Get mask for first byte of the row
	and	eax,edi		;Apply pattern mask
	out	dx,al		;Set up the Bit_Mask register
	not	byte ptr [esi]	;Do a read/modify/write cycle to REGEN buffer
	lea	ebx,[esi+1]
	mov	eax,edi		;Copy the pattern mask
        mov     ah,ch           ;Copy row's full byte count + 1
	dec	ah		;Are there any more bytes?
	jz      short dsgly4b	;Yes, but only a trailing "partial" byte
	jl	short dsgly5	;No, we just did the whole row
	out	dx,al		;Set up pattern mask for full bytes
	align	4
dsgly4a:
	not	byte ptr [ebx]	;Read/modify/write cycle to REGEN buffer
	inc	ebx
	dec	ah
	jnz	short dsgly4a 	;Loop for all of the full bytes

;	Do the last byte of the row
	align	4
dsgly4b:
	mov	al,byte ptr rowmask+1	;Get the mask for the last byte
	and	eax,edi		;Apply pattern mask
	out	dx,al		;Send it to the Graphics chip
	not	byte ptr [ebx]	;Read/modify/write cycle to REGEN buffer

;	End a row
	align	4
dsgly5: rol	di,cl		;Shift pattern mask for the next row
	add	esi,80		;Advance to the next row
	mov	ebx,esi
	dec	dword ptr deltay	;Decrement remaining row count
	jnz	short dsgly4		;Loop for next row
	jmp	short dsglyr

;	Normal ICON Buffer loop
	align	4
dsgly6:
	mov	eax,deltax	;Delta X (in pixels)
	add	eax,7		;Round up to include any partial bytes
	shr	eax,3		;Number of bytes of icon buffer per row

	mov	patmask,edi
	mov	rowstart,ebx
	mov	rowcount,eax
	mov	bh,cl		;make a copy of alignment shift count

	align	4
dsgly7:
	mov	edi,rowstart 	;get starting position of the row
	mov	bl,byte ptr rowcount	;get length of a row in bytes
	xor	ch,ch		;No previous byte for the very first byte
;	now EDI is REGEN pointer, and BL is length of a row in bytes.
	align	4
dsgly8:
	lodsb			;Get byte of icon definition
	mov	ah,ch		;Get previous byte of icon definition
	mov	ch,al		;Hold this byte for the next iteration
	ror	ax,cl		;Align them in al
	and	eax,patmask;Apply pattern mask
	out	dx,al		;Send to the Graphic chip Bit Mask Register
	not	byte ptr [edi]	;Do a read modify write cycle (actual data
				;	is irrelevant)
	inc	edi		;Advance to next byte
	dec	bl		;Decrement bytes left in this row
	jnz	short dsgly8	;Loop till end of row
	xor	al,al		;Do one extra pass with zero as the last byte
	mov	ah,ch
	ror	ax,cl
	and	eax,patmask
	out	dx,al
	not	byte ptr [edi]
	mov	cl,byte ptr shiftcnt	;Get the highlighting shift count
	rol	word ptr patmask,cl ;Shift the greying (highlighting) mask
	mov	cl,bh		;Restore the alignment shift count
	add	dword ptr rowstart,80 ;Move to next row of icon box.
	dec	dword ptr deltay
	jnz	short dsgly7	;Loop for all rows
	align	4
dsglyr:
	mov	al,0FFh
	out	dx,al		;Restore Bit Mask Register
	dec	edx
	OUT_DX	G_SET_RESET,0	;Restore G_SET_RESET to normalcy
	OUT_DX	G_ENBL_SET,0	;Same for G_ENBL_SET
	OUT_DX	G_DATA_ROT,REP_MODE

	pop	ebx
	pop	edi
	pop	esi
	leave
	ret
_adsglyph endp



	ifdef debug
	call near pvars
bpoint	proc	near
;debugging break point routine
;prints registers with heading
	pushf
	push	ds
	push	ax
	mov	ax,seg dgroup:head
	mov	ds,ax
	pop	ax
	mov	sax,ax
	pushf
	pop	ax
	mov	sflags,ax
	mov	sbx,bx
	mov	scx,cx
	mov	sdx,dx
	mov	ax,es
	mov	ses,ax
	pop	ax
	push	ax		;put old ds back on stack
	mov	sds,ax
	mov	ax,cs
	mov	scs,ax
	mov	ax,ss
	mov	sss,ax
	mov	ax,bp
	mov	sbp,ax
	mov	ax,si
	mov	ssi,ax
	mov	ax,di
	mov	sdi,ax
	mov	ax,sp
	mov	ssp,ax
	push	bp
	mov	bp,sp
	mov	ax,[ebp+6]
	mov	sip,ax
	mov	ax,[ebp+4]
	mov	ipl,ax
	pop	bp
;print heading about here
	mov	cl,85
	mov	bx,offset dgroup:head
	align 4
headl:	mov	al,ds:[bx]
	cmp	al,'$'
	jz	ehead
	call	charout
	inc	bx
	dec	cl
	jnz	headl
	align 4
ehead:
;start printing registers here
	mov	bx,offset dgroup:sax	;start of list
	mov	cl,15		;15 2 byte numbers to report
	align 4
bpl:	mov	al,ds:[bx+1] ;fetch high order byte
	mov	ah,al
	ror	al,1
	ror	al,1
	ror	al,1
	ror	al,1
	and	al,0fh
	call	hexout		;print high nibble
	mov	al,ah
	and	al,0fh
	call	hexout		;print low nibble
	mov	al,ds:[bx]	;fetch low order byte
	mov	ah,al
	ror	al,1
	ror	al,1
	ror	al,1
	ror	al,1
	and	al,0fh
	call	hexout		;print high nibble
	mov	al,ah
	and	al,0fh
	call	hexout		;print low nibble
	mov	al,20h
	call	charout		;space it
	inc	bx
	inc	bx		;space ahead 2 bytes
	dec	cl		;count one register
	jnz	bpl		;loop until all done
	call	crlf
	mov	cx,scx		;restore the basic registers
	mov	bx,sbx
	mov	ax,sax
	pop	ds
	popf
	ret

bpoint	endp


;various entry points for different numbers of arguments 
pvars1:	pushf
	mov	numargs,1
	jmp	pvcom

pvars2: pushf
	mov	numargs,2
	jmp	pvcom

pvars3:	pushf
	mov	numargs,3
	jmp	pvcom

pvars6:	pushf
	mov	numargs,6
	jmp	pvcom



pvars10: pushf
	mov	numargs,10
	jmp pvcom

;print variables for debugging
pvars	proc	near
	pushf
	mov	numargs,5
pvcom:
	push	ax
	push	bx
	push	cx
	push	ds
	mov	ax,seg dgroup:phead
	mov	ds,ax
	mov	cl,10
	mov	bx,offset dgroup:phead
	call	pheadl

	call	crlf

	mov	eax,_ecurwind
	call	wordout

	call	crlf
	
	mov	cl,10
	mov	bx,offset dgroup:ahead
	call	pheadl

;OS/2 will complain if we try to access more args than were
;specified in the module definition file
	mov	cx,numargs
	cmp	cx,0
	jz	argd
	mov	si,6
argl:	mov	ax,[bp][si]
	call	wordout
	add	si,2
	dec	cx
	jnz	argl
argd:	call	crlf

	pop	ds
	pop	cx
	pop	bx
	pop	ax
	popf
	ret
pvars	endp

pheadl	proc	near
	mov	al,ds:[bx]
	cmp	al,'$'
	jz	pehead
	call	charout
	inc	bx
	dec	cl
	jnz	pheadl
pehead:	ret
pheadl	endp

spac	proc	near
	mov	al,20h
	call	charout
	mov	al,20h
	call	charout
	mov	al,20h
	call	charout
	ret
spac	endp

crlf	proc	near
	mov	al,0dh
	call	charout
	mov	al,0ah
	call	charout
	ret
crlf	endp

hexout	proc	near
	;print the nibble in al as a hex digit
	cmp	al,10
	jc	small
	add	al,7
small:	add	al,30h
EXTRN DOSWRITE:FAR
charout: pushf
	push	bx
	push	dx
	push	ax

	mov	dx,378h
	out	dx,al
	inc	dx
busy:	in	al,dx
	test	al,80h
	jz	busy
	mov	al,0dh
	inc	dx
	out	dx,al
	mov	al,0ch
	out	dx,al
	
	pop	ax
	pop	dx
	pop	bx
	popf
	ret
hexout	endp

pwd	proc	near
	mov	al,ds:[bx+1] ;fetch high order byte
	call	byteout
	call	pbyt		;print low order byte & space 1
	inc	bx		;space ahead 1 more byts
	ret
pwd	endp

pbyt	proc	near
	mov	al,ds:[bx]	;fetch low order byte
	call	byteout
	mov	al,20h
	call	charout		;space it
	inc	bx
	ret
pbyt	endp

byteout	proc	near
	;enter with byte in al, print hex
	mov	ah,al
	ror	al,1
	ror	al,1
	ror	al,1
	ror	al,1
	and	al,0fh
	call	hexout		;print high nibble
	mov	al,ah
	and	al,0fh
	call	hexout		;print low nibble
	ret
byteout	endp

wordout	proc	near
	;enter with word in ax, print hex, trash bl
	push	ax
	mov	bl,al
	mov	al,ah	;print high nibble first
	call	byteout
	mov	al,bl
	call	byteout
	mov	al,20h
	call	charout
	pop	ax
	ret
wordout	endp


clabel: pushf
	push	ax
	mov	al,'c'
	jmp	cp

blabel:	pushf
	push	ax
	mov	al,'b'
	jmp	cp

alabel	proc	near
	pushf
	push	ax
	mov	al,'a'
cp:	call	charout
	mov	al,0dh
	call	charout
	pop	ax
	popf
	ret
alabel	endp

	endif


_TEXT	ENDS
  END

